/* SetSB, by Jeremiah Blanchard
   To the reader: This code is VERY, VERY, VERY beta. It's written mainly
   because there was a piece of shareware that was annoying the living
   hell out of me. I'm really sick of seeing shareware that shouldn't be
   shareware, but free software, so I wrote this mixer settings program
   in the hopes that some of you will find it easier to set your mixer up
   upon the startup of your computer without getting any annoying messages
   or beeps. And remember, information wants to be free... and so does
   software!

   P.S. Sorry that there aren't many comments in the code; I got some of the
   code ideas from creative. Of course, all rights have been released on it,
   so everything's okee dokee. In actuality, I had a helluva time figuring
   out how it works. The code I got wasn't even for a mixer settings program,
   it was from a voc file mixer.  At any rate, if you interested in the code,
   try going to www.creativelabs.com and checking in the programming section.
   BTW, remember that this code is under the GPL - that means that you can't
   copyright it or any modification. However, you can modify it and
   distribute it, or pull code right out of it, under the terms of the GPL.

   P.P.S.  If you have any questions, feel free to email me at
   squirminworm@geocities.com
	     -or-
   jeremiahblanchard@juno.com */

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define dspReady 0xAA     /* byte returned by DSP when ready after reset */
#define MASTERVOL 0x22
#define VOCVOL    0x04
#define FMVOL     0x26
#define CDVOL     0x28
#define MICVOL    0x0A
#define ADCSELECT 0x0C

struct {                                          // Structure for file
   struct {unsigned char left, right;}
   VoiceVol, MasterVol, MicVol, CDVol, MIDIVol;
   int sbaddr;
       } vol;

void dspin(unsigned int *val)
/* Read a value from the dsp.  Poll the Data Available bit until it is 1,
 * then read the value from the read data port.
 */
{
   int dspaddrReadData=vol.sbaddr+0xA;    /* DSP Read Data address */
   int dspaddrDataAvail=vol.sbaddr+0xE;    /* DSP Data Available address */


   while (!(inp(dspaddrDataAvail) & 0x80)) {
      ;
   }
   *val=inp(dspaddrReadData);
}

void dspout(unsigned int val)
/* Outputs a byte to the dsp.  This polls the write buffer status bit, waits
  for it to be 0, then outputs the value to the write buffer.
  The C equivalent code is:
     while (inp(dspaddrWrBuf) & 0x80)
	 ;
     outp(dspaddrWrBuf,val);
*/
{

int dspaddrWrBuf=vol.sbaddr+0xC;    /* DSP Write Buffer address */

   asm {
      mov dx,dspaddrWrBuf
   }
   test:
   asm {
      in al,dx
      or al,al
      js test
      mov al,byte ptr val
      out dx,al
   }
}

void SetMixer(void)
/* Resets the Sound Blaster card and sets the volume levels in the SB-PRO
 * mixer chip.
 */
{
   unsigned int val;

   int mixeraddr=vol.sbaddr+0x4;    /* mixer address (register select) port */
   int mixerdata=vol.sbaddr+0x5;    /* mixer data port */
   int dspaddrReset=vol.sbaddr+0x6;    /* dsp reset port address */

  clrscr();
printf("SetSB Sound Blaster Mixer Setting Utility\r\n");
printf("Copyright (C) 1998 Jeremiah Blanchard - FEEL FREE TO DISTRIBUTE!\r\n");
printf("This program is distributed under the terms of the\r\n");
printf("GNU General Public License.  See GPL.DOC for more information.\r\n\r\n");
   outp(dspaddrReset,1);       /* reset DSP */
   delay(1);
   outp(dspaddrReset,0);
   dspin(&val);
   if (val!=dspReady)
      printf("SBPRO not ready.\r\n\r\n");

   outp(mixeraddr,MICVOL);
   outp(mixerdata,vol.MicVol.right*2); /* set microphone */
   outp(mixeraddr,VOCVOL);
   outp(mixerdata,vol.VoiceVol.left*16+vol.VoiceVol.right); /* set voice */
   outp(mixeraddr,MASTERVOL);
   outp(mixerdata,vol.MasterVol.left*16+vol.MasterVol.right);/* set master */
   outp(mixeraddr,CDVOL);
   outp(mixerdata,vol.CDVol.left*16+vol.CDVol.right);       /* set CD */
   outp(mixeraddr,FMVOL);
   outp(mixerdata,vol.MIDIVol.left*16+vol.MIDIVol.right);  /* set MIDI */
   dspout(0xD1);               /* turn speaker on */

   printf("Initialized with the following values:\r\n\r\n");
   printf("Channel -         Left       Right\r\n");
   printf("Voice Volume       %3d         %3d\r\n",
	   vol.VoiceVol.left, vol.VoiceVol.right);
   printf("Master Volume      %3d         %3d\r\n",
	   vol.MasterVol.left, vol.MasterVol.right);
   printf("CD Player Volume   %3d         %3d\r\n",
	   vol.CDVol.left, vol.CDVol.right);
   printf("MIDI Volume        %3d         %3d\r\n\r\n",
	   vol.MIDIVol.left, vol.MIDIVol.right);
   printf("Mic Volume         %3d   Hex   %3x\r\n\r\n",
	   vol.MicVol.right, vol.sbaddr);
   printf("Support free software! USE IT!\r\n\r\n");
}

int openfile(char *fname)
{
   FILE *f;

   if ((f=fopen(fname,"rb"))==NULL) return 1;

   fseek(f,0,SEEK_SET);     /* seek */
   fread(&vol, sizeof(vol), 1, f);   /* read it */
   fclose(f);

   return 0;
}

char parseparam(char far *param) /* parameter parser */
{
   int index;

   if (param[0]!='-' &&      	/* if it doesn't start with - or /, */
       param[0]!='/')        	/* then is it a suitable filename? */
       {
	for (index=0; index <=strlen(param); index++)
	    {
	     if (param[index]=='\0') break; /* if end of string, end loop */
	     if (iscntrl(param[index]))
		{
		 printf("Invalid filename. For help, try setsb -h\r\n\r\n");
		 exit(1);/* if it's not a valid filename, exit with an error. */
		}
	    }
	return(1);
       }

   else if (param[0]=='-' ||	/* if it DOES start with - or /, check */
	    param[0]=='/')      /* for parameters. */
      {
       if (toupper(param[1])=='H' ||  /* if it's one of the help parameters, */
	   param[1]=='?')             /* display the help and exit. */
	  {
	   printf("Usage:\r\n");
	   printf("setsb [-parameter]\r\n");
	   printf("or\r\n");
	   printf("setsb [filename]\r\n\r\n");
	   printf("Parameters:\r\n");
	   printf("h, ?  -  this screen\r\n");
	   printf("s     -  invokes setup\r\n\r\n");
	   printf("[filename] is the name of the configuration file.\r\n\r\n");
	   exit(0); /* exit without error. */
	  }
       else if (toupper(param[1])=='S') return(2); /* if it's for setup, */
	    else   	/* return value of 2. Otherwise, */
	  {
	   printf("Invalid parameter. For help, try setsb -h\r\n\r\n");
	   exit(1); /* exit with error. */
	  }
      }
   else
      {
       printf("Invalid command line. For help, try setsb -h\r\n\r\n");
       exit(1); /* if none of the above, exit with error. */
      }
return(0);
}

char DispMenu()
{
 union {int decm;
   unsigned char character:4;	 /* union for input; so that generic %d can */
   unsigned char micbits:2;} val;/* be used with pointers properly. */

 char far *buf, *buf2;		/* buffers for sscanf. */
 char strval[10], choiceval;	/* string for choices. */
 unsigned char *pt;		/* pointer to variable to be set */
 clrscr();
 printf("Here's the current data:\r\n"); /* print the current data to screen */
 printf("(A)Left VoiceVol:   %10d (F)Left CDVol:     %10d\r\n",
 vol.VoiceVol.left, vol.CDVol.left);
 printf("(B)Right VoiceVol:  %10d (G)Right CDVol:    %10d\r\n",
 vol.VoiceVol.right, vol.CDVol.right);
 printf("(C)Left MasterVol:  %10d (H)Left MIDIVol:   %10d\r\n",
 vol.MasterVol.left, vol.MIDIVol.left);
 printf("(D)Right MasterVol: %10d (I)Right MIDIVol:  %10d\r\n",
 vol.MasterVol.right, vol.MIDIVol.right);
 printf("(E)MicVol:          %10d (J)SB Hex Address: %10x\r\n",
 vol.MicVol.right, vol.sbaddr);
 printf("\r\n(Q)uit\r\n\r\n");

 printf("Please select one: ");
 choiceval=toupper(getche()); /* get a character from the user. */
 fflush(stdin);
 switch (choiceval)
 {  /* set string and pointer accordingly for generic values. */
  case 'A': strcpy(strval, "Left VoiceVol"); pt=&vol.VoiceVol.left; break;
  case 'B': strcpy(strval, "Right VoiceVol"); pt=&vol.VoiceVol.right; break;
  case 'C': strcpy(strval, "Left MasterVol"); pt=&vol.MasterVol.left; break;
  case 'D': strcpy(strval, "Right MasterVol"); pt=&vol.MasterVol.right; break;
  case 'E':
  printf("\r\n\r\nPlease enter a value for MicVol (0-3): ");
  scanf("%d", &val.decm);
  vol.MicVol.right=val.micbits;
  fflush(stdin);
  return(0);
  strcpy(strval, "MicVol"); pt=&vol.MicVol.right; break;
  case 'F': strcpy(strval, "Left CDVol"); pt=&vol.CDVol.left; break;
  case 'G': strcpy(strval, "Right CDVol"); pt=&vol.CDVol.right; break;
  case 'H': strcpy(strval, "Left MIDIVol"); pt=&vol.MIDIVol.left; break;
  case 'I': strcpy(strval, "Right MIDIVol"); pt=&vol.MIDIVol.right; break;
  case 'J':  /* if it's setting the SB hex value, */
  printf("\r\n\r\nPlease enter a new hex value: 0x"); /* prompt for hex. */
  gets(buf); /* get the hex (generally 220 or 240) */
  strcpy(buf2, "0x"); /* set buf2 to "0x" <start of hex> */
  strcat(buf2, buf);  /* set buf2 to "0x" + buf (ex. "0x"+"220"="0x220") */
  sscanf(buf2, "%x", &vol.sbaddr); /* set the value to the sbaddr variable. */
  fflush(stdin); /* flush the input buffer. */
  return(0);     /* return, continue. */
  case 'Q': return(1); /* return, quit. */
  default: printf ("\r\n\r\nNot a choice.");getch();return(0);
 } /* if none of the above, print "Not a choice and return, continue. */
 printf("\r\n\r\nPlease enter a value for %s (0-15): ",strval); /* prompt for value */
 scanf("%d", &val.decm); /* get int value */
 *pt = val.character; /* set the variable the address is pointing to to */
 fflush(stdin); /* the first four bits of the input (0-15). Then flush input.*/
 return(0); /* return, continue. */
}

char setupmixer(char far *filename)  /* main setup function */
{
   FILE *f;     /* file pointer */
   char rv=0;     /* character for keeping track of DispMenu function */
   char yn;	/* character holding answer to [y/N] question */

   if (!((f=fopen(filename,"rb"))==NULL)) {  /* if the file does open, */

   fseek(f,0,SEEK_SET);     /* seek */
   fread(&vol, sizeof(vol), 1, f);   /* read it */
   fclose(f);				/* close it. */

   }
   else	   /* If it can't be opened, start a new one with its name. */
      {
       printf("File doesn't seem to exist, or can't be accessed. Starting\r\n");
       printf("a new file with filename.\r\n");
       getch();
       vol.MicVol.right=0;	/* set values to 0. */
       vol.VoiceVol.left=0;
       vol.VoiceVol.right=0;
       vol.MasterVol.left=0;
       vol.MasterVol.right=0;
       vol.CDVol.left=0;
       vol.CDVol.right=0;
       vol.MIDIVol.left=0;
       vol.MIDIVol.right=0;
       vol.sbaddr=0x220;	/* set sbaddr to default. */
      }

   while (rv!=1)		/* while the return value is 0, DispMenu.*/
       rv=DispMenu();

   clrscr();
   printf("Saving....");
				// If there's an error, tell em!
   if ((f=fopen(filename,"wb"))==NULL) printf("Error saving file.\r\n\r\n");

   else
   {
   fwrite(&vol, sizeof(vol), 1, f);   /* write it */
   fclose(f);
   printf("done!\r\n\r\n");
   }
   printf("\r\nWrite values to SB registers[y/N]? "); /* Write to registers? */
   yn=toupper(getche());
   if (yn=='Y') return(1); else return(0);
}


void main(int argc, char *argv[])
{
   char far *param1, *param2, *param3, *filename=""; /* parameters, filename */
   char p1val=0, p2val=0, err, setupr; /* return values of parameters */
   if (argc > 1)		/* parameter 1 */
      {
       strcpy(param1, argv[1]);
       p1val=parseparam(param1);
      }

   if (argc > 2)		/* parameter 2 */
      {
       strcpy(param2, argv[2]);
       p2val=parseparam(param2);
      }

   if (argc > 3)		/* parameter 3 */
      {
       strcpy(param3, argv[3]);
       parseparam(param3);
      }

   if (p1val==0)
      {
       printf("No parameters. For help, try setsb -h\r\n\r\n");
       exit(1); /* If no parameters, exit with error. */
      }

   if (p1val==2 && p2val==0 || /* if none of the parameters is a filename, */
       p1val==0 && p2val==2)
      {
       printf("Setup requires a filename. Please enter a filename: ");
       scanf("%s",filename); /* Ask for one. */
       fflush(stdin); /* flush input. */
      }
   if (p1val==1 && p2val==1) /* If two filenames were entered, alert user. */
      {
       printf("Two filenames entered. Using file #1.");
      }
   if (p2val==1)		/* Copy parameter to filename if it's a */
       strcpy(filename, param2);/* valid filename, 2nd parameter first. */
       if (p1val==1)
       strcpy(filename, param1);

   if (p1val==2 || p2val==2) /* If one of the parameters is setup, run it. */
      {
       setupr=setupmixer(filename);
       if (setupr==0) {
 printf("This program is distributed under the terms of the\r\n");
 printf("GNU General Public License.  See GPL.DOC for more information.\r\n");
 exit(0); }

      }

   if (0 != (err=openfile(filename))) { /* Open file for SetMixer function*/
      printf("Error %d opening %s.\n",err,filename);
      exit(1);
   }
   SetMixer(); /* Run SetMixer function. */
}